"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const asAsyncSortedKeyValues_1 = require("./_ordered/asAsyncSortedKeyValues");
const asAsyncSortedKeyValuesSync_1 = require("./_ordered/asAsyncSortedKeyValuesSync");
const asSortedKeyValues_1 = require("./_ordered/asSortedKeyValues");
const asSortedKeyValuesSync_1 = require("./_ordered/asSortedKeyValuesSync");
const BasicAsyncEnumerable_1 = require("./BasicAsyncEnumerable");
/**
 * Ordered Async Enumerable
 */
class OrderedAsyncEnumerable extends BasicAsyncEnumerable_1.BasicAsyncEnumerable {
    constructor(orderedPairs) {
        super(function () {
            return tslib_1.__asyncGenerator(this, arguments, function* () {
                var e_1, _a;
                try {
                    for (var _b = tslib_1.__asyncValues(orderedPairs()), _c; _c = yield tslib_1.__await(_b.next()), !_c.done;) {
                        const orderedPair = _c.value;
                        yield tslib_1.__await(yield* tslib_1.__asyncDelegator(tslib_1.__asyncValues(orderedPair)));
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) yield tslib_1.__await(_a.call(_b));
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            });
        });
        this.orderedPairs = orderedPairs;
    }
    static generateAsync(source, keySelector, ascending, comparer) {
        let orderedPairs;
        if (source instanceof OrderedAsyncEnumerable) {
            orderedPairs = function () {
                return tslib_1.__asyncGenerator(this, arguments, function* () {
                    var e_2, _a;
                    try {
                        for (var _b = tslib_1.__asyncValues(source.orderedPairs()), _c; _c = yield tslib_1.__await(_b.next()), !_c.done;) {
                            const pair = _c.value;
                            yield tslib_1.__await(yield* tslib_1.__asyncDelegator(tslib_1.__asyncValues(asAsyncSortedKeyValuesSync_1.asAsyncSortedKeyValuesSync(pair, keySelector, ascending, comparer))));
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) yield tslib_1.__await(_a.call(_b));
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                });
            };
        }
        else {
            orderedPairs = () => asAsyncSortedKeyValues_1.asAsyncSortedKeyValues(source, keySelector, ascending, comparer);
        }
        return new OrderedAsyncEnumerable(orderedPairs);
    }
    static generate(source, keySelector, ascending, comparer) {
        let orderedPairs;
        if (source instanceof OrderedAsyncEnumerable) {
            orderedPairs = function () {
                return tslib_1.__asyncGenerator(this, arguments, function* () {
                    var e_3, _a;
                    try {
                        for (var _b = tslib_1.__asyncValues(source.orderedPairs()), _c; _c = yield tslib_1.__await(_b.next()), !_c.done;) {
                            const pair = _c.value;
                            yield tslib_1.__await(yield* tslib_1.__asyncDelegator(tslib_1.__asyncValues(asSortedKeyValuesSync_1.asSortedKeyValuesSync(pair, keySelector, ascending, comparer))));
                        }
                    }
                    catch (e_3_1) { e_3 = { error: e_3_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) yield tslib_1.__await(_a.call(_b));
                        }
                        finally { if (e_3) throw e_3.error; }
                    }
                });
            };
        }
        else {
            orderedPairs = () => asSortedKeyValues_1.asSortedKeyValues(source, keySelector, ascending, comparer);
        }
        return new OrderedAsyncEnumerable(orderedPairs);
    }
    thenBy(keySelector, comparer) {
        return OrderedAsyncEnumerable.generate(this, keySelector, true, comparer);
    }
    thenByAsync(keySelector, comparer) {
        return OrderedAsyncEnumerable.generateAsync(this, keySelector, true, comparer);
    }
    thenByDescending(keySelector, comparer) {
        return OrderedAsyncEnumerable.generate(this, keySelector, false, comparer);
    }
    thenByDescendingAsync(keySelector, comparer) {
        return OrderedAsyncEnumerable.generateAsync(this, keySelector, false, comparer);
    }
}
exports.OrderedAsyncEnumerable = OrderedAsyncEnumerable;
