"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
/**
 * Iterates through the object
 * @param source Source Object
 * @returns IAsyncEnumerabe<[TKey, TValue]> of Key Value pairs
 */
function enumerateObject(source) {
    function iterable() {
        return tslib_1.__asyncGenerator(this, arguments, function* iterable_1() {
            /* tslint:disable */
            for (const key in source) {
                yield yield tslib_1.__await([key, source[key]]);
            }
            /* tslint:enable */
        });
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterable);
}
exports.enumerateObject = enumerateObject;
