"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const ErrorString_1 = require("../../shared/ErrorString");
const InvalidOperationException_1 = require("../../shared/InvalidOperationException");
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
function from(promisesOrIterable) {
    if (Array.isArray(promisesOrIterable)) {
        if (promisesOrIterable.length === 0) {
            throw new InvalidOperationException_1.InvalidOperationException(ErrorString_1.ErrorString.NoElements);
        }
        return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(function () {
            return tslib_1.__asyncGenerator(this, arguments, function* () {
                var e_1, _a;
                try {
                    for (var promisesOrIterable_1 = tslib_1.__asyncValues(promisesOrIterable), promisesOrIterable_1_1; promisesOrIterable_1_1 = yield tslib_1.__await(promisesOrIterable_1.next()), !promisesOrIterable_1_1.done;) {
                        const value = promisesOrIterable_1_1.value;
                        yield yield tslib_1.__await(value);
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (promisesOrIterable_1_1 && !promisesOrIterable_1_1.done && (_a = promisesOrIterable_1.return)) yield tslib_1.__await(_a.call(promisesOrIterable_1));
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            });
        });
    }
    else {
        return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(promisesOrIterable);
    }
}
exports.from = from;
