"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
function zip(first, second, resultSelector) {
    if (resultSelector) {
        return zip_2(first, second, resultSelector);
    }
    else {
        return zip_1(first, second);
    }
}
exports.zip = zip;
function zip_1(source, second) {
    function iterator() {
        return tslib_1.__asyncGenerator(this, arguments, function* iterator_1() {
            const firstIterator = source[Symbol.asyncIterator]();
            const secondIterator = second[Symbol.asyncIterator]();
            while (true) {
                const result = yield tslib_1.__await(Promise.all([firstIterator.next(), secondIterator.next()]));
                const a = result[0];
                const b = result[1];
                if (a.done && b.done) {
                    break;
                }
                else {
                    yield yield tslib_1.__await([a.value, b.value]);
                }
            }
        });
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
}
function zip_2(source, second, resultSelector) {
    function iterator() {
        return tslib_1.__asyncGenerator(this, arguments, function* iterator_2() {
            const firstIterator = source[Symbol.asyncIterator]();
            const secondIterator = second[Symbol.asyncIterator]();
            while (true) {
                const result = yield tslib_1.__await(Promise.all([firstIterator.next(), secondIterator.next()]));
                const a = result[0];
                const b = result[1];
                if (a.done && b.done) {
                    break;
                }
                else {
                    yield yield tslib_1.__await(resultSelector(a.value, b.value));
                }
            }
        });
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
}
