"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const asAsyncKeyMapSync_1 = require("./asAsyncKeyMapSync");
/**
 * Sorts values in an Async Iterable based on key and a key comparer.
 * @param source Iterable
 * @param keySelector Async Key Selector
 * @param ascending Ascending or Descending Sort
 * @param comparer Key Comparer for Sorting. Optional.
 * @returns Async Iterable Iterator of arrays
 */
function asAsyncSortedKeyValuesSync(source, keySelector, ascending, comparer) {
    return tslib_1.__asyncGenerator(this, arguments, function* asAsyncSortedKeyValuesSync_1() {
        const map = yield tslib_1.__await(asAsyncKeyMapSync_1.asAsyncKeyMapSync(source, keySelector));
        const sortedKeys = [...map.keys()].sort(comparer ? comparer : undefined);
        if (ascending) {
            for (let i = 0; i < sortedKeys.length; i++) {
                yield yield tslib_1.__await(map.get(sortedKeys[i]));
            }
        }
        else {
            for (let i = sortedKeys.length - 1; i >= 0; i--) {
                yield yield tslib_1.__await(map.get(sortedKeys[i]));
            }
        }
    });
}
exports.asAsyncSortedKeyValuesSync = asAsyncSortedKeyValuesSync;
