"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
// tslint:disable:completed-docs
/**
 * @private Next Iteration for Parallel Enumerable
 */
function nextIterationAsync(source, onfulfilled) {
    const dataFunc = source.dataFunc;
    switch (dataFunc.type) {
        case 0 /* PromiseToArray */: {
            const generator = () => tslib_1.__awaiter(this, void 0, void 0, function* () {
                const results = yield dataFunc.generator();
                const newPromises = new Array(results.length);
                for (let i = 0; i < results.length; i++) {
                    newPromises[i] = onfulfilled(results[i]);
                }
                return newPromises;
            });
            return {
                generator,
                type: 2 /* PromiseOfPromises */,
            };
        }
        case 1 /* ArrayOfPromises */: {
            const generator = () => dataFunc
                .generator()
                .map((promise) => promise.then(onfulfilled));
            return {
                generator,
                type: 1 /* ArrayOfPromises */,
            };
        }
        case 2 /* PromiseOfPromises */: {
            const generator = () => tslib_1.__awaiter(this, void 0, void 0, function* () {
                const promises = yield dataFunc.generator();
                return promises.map((promise) => promise.then(onfulfilled));
            });
            return {
                generator,
                type: 2 /* PromiseOfPromises */,
            };
        }
    }
}
exports.nextIterationAsync = nextIterationAsync;
