"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const ErrorString_1 = require("../../shared/ErrorString");
const InvalidOperationException_1 = require("../../shared/InvalidOperationException");
const BasicParallelEnumerable_1 = require("../BasicParallelEnumerable");
const _nextIteration_1 = require("./_nextIteration");
function max(source, selector) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        let maxInfo;
        if (selector) {
            const dataFunc = _nextIteration_1.nextIteration(source, selector);
            maxInfo = yield new BasicParallelEnumerable_1.BasicParallelEnumerable(dataFunc).toArray();
        }
        else {
            maxInfo = yield source.toArray();
        }
        if (maxInfo.length === 0) {
            throw new InvalidOperationException_1.InvalidOperationException(ErrorString_1.ErrorString.NoElements);
        }
        return Math.max.apply(null, maxInfo);
    });
}
exports.max = max;
