"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const ErrorString_1 = require("../../shared/ErrorString");
const InvalidOperationException_1 = require("../../shared/InvalidOperationException");
const BasicParallelEnumerable_1 = require("../BasicParallelEnumerable");
const _nextIteration_1 = require("./_nextIteration");
function min(source, selector) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        let minInfo;
        if (selector) {
            const dataFunc = _nextIteration_1.nextIteration(source, selector);
            minInfo = yield new BasicParallelEnumerable_1.BasicParallelEnumerable(dataFunc)
                .toArray();
        }
        else {
            minInfo = yield source.toArray();
        }
        if (minInfo.length === 0) {
            throw new InvalidOperationException_1.InvalidOperationException(ErrorString_1.ErrorString.NoElements);
        }
        return Math.min.apply(null, minInfo);
    });
}
exports.min = min;
