"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
/**
 * Paritions the Iterable<T> into a tuple of failing and passing arrays
 * based on the predicate.
 * @param source Elements to Partition
 * @param predicate Pass / Fail condition
 * @returns [pass, fail]
 */
exports.partitionAsync = (source, predicate) => { var source_1, source_1_1; return tslib_1.__awaiter(this, void 0, void 0, function* () {
    var e_1, _a;
    const fail = [];
    const pass = [];
    try {
        for (source_1 = tslib_1.__asyncValues(source); source_1_1 = yield source_1.next(), !source_1_1.done;) {
            const value = source_1_1.value;
            if ((yield predicate(value)) === true) {
                pass.push(value);
            }
            else {
                fail.push(value);
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (source_1_1 && !source_1_1.done && (_a = source_1.return)) yield _a.call(source_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return [pass, fail];
}); };
