"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
function sum(source, selector) {
    if (selector) {
        return sum_2(source, selector);
    }
    else {
        return sum_1(source);
    }
}
exports.sum = sum;
function sum_1(source) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        let totalSum = 0;
        for (const value of yield source.toArray()) {
            totalSum += value;
        }
        return totalSum;
    });
}
function sum_2(source, selector) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        let total = 0;
        for (const value of yield source.toArray()) {
            total += selector(value);
        }
        return total;
    });
}
