"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
/**
 * Computes the sum of the sequence of numeric values that are obtained by invoking a transform function
 * on each element of the input sequence.
 * @param source A sequence of values that are used to calculate a sum.
 * @param selector A transform function to apply to each element.
 */
function sumAsync(source, selector) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        let total = 0;
        for (const value of yield source.toArray()) {
            total += yield selector(value);
        }
        return total;
    });
}
exports.sumAsync = sumAsync;
