"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
/**
 * Creates an array from a IParallelEnumerable<T>.
 * @param source An IParallelEnumerable<T> to create an array from.
 * @returns An array of elements
 */
function toArray(source) {
    const dataFunc = source.dataFunc;
    switch (dataFunc.type) {
        case 0 /* PromiseToArray */:
            return dataFunc.generator();
        case 1 /* ArrayOfPromises */:
            return Promise.all(dataFunc.generator());
        case 2 /* PromiseOfPromises */:
            return (() => tslib_1.__awaiter(this, void 0, void 0, function* () {
                const data = yield dataFunc.generator();
                return Promise.all(data);
            }))();
        default:
            throw new Error("Not Implemented");
    }
}
exports.toArray = toArray;
