"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
/**
 * Determines whether any element of a sequence satisfies a condition.
 * @param source An IEnumerable<T> whose elements to apply the predicate to.
 * @param predicate A function to test each element for a condition.
 */
function anyAsync(source, predicate) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        for (const item of source) {
            if ((yield predicate(item)) === true) {
                return true;
            }
        }
        return false;
    });
}
exports.anyAsync = anyAsync;
