"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
/**
 * Determines whether a sequence contains a specified element by using the specified or default IEqualityComparer<T>.
 * @param source A sequence in which to locate a value.
 * @param value The value to locate in the sequence.
 * @param comparer An equality comparer to compare values. Optional.
 */
function containsAsync(source, value, comparer) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        for (const item of source) {
            if (yield comparer(value, item)) {
                return true;
            }
        }
        return false;
    });
}
exports.containsAsync = containsAsync;
