"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
/**
 * Returns the number of elements in a sequence
 * or represents how many elements in the specified sequence satisfy a condition
 * if the predicate is specified.
 * @param source A sequence that contains elements to be counted.
 * @param predicate A function to test each element for a condition. Optional.
 */
function countAsync(source, predicate) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        let count = 0;
        for (const value of source) {
            if ((yield predicate(value)) === true) {
                count++;
            }
        }
        return count;
    });
}
exports.countAsync = countAsync;
