import { ErrorString } from "../../shared/ErrorString";
import { InvalidOperationException } from "../../shared/InvalidOperationException";
export function min(source, selector) {
    if (selector) {
        return min_2(source, selector);
    }
    else {
        return min_1(source);
    }
}
async function min_1(source) {
    let minValue = null;
    for await (const item of source) {
        minValue = Math.min(minValue || Number.POSITIVE_INFINITY, item);
    }
    if (minValue === null) {
        throw new InvalidOperationException(ErrorString.NoElements);
    }
    else {
        return minValue;
    }
}
async function min_2(source, selector) {
    let minValue = null;
    for await (const item of source) {
        minValue = Math.min(minValue || Number.POSITIVE_INFINITY, selector(item));
    }
    if (minValue === null) {
        throw new InvalidOperationException(ErrorString.NoElements);
    }
    else {
        return minValue;
    }
}
