import { BasicAsyncEnumerable } from "../BasicAsyncEnumerable";
export function selectAsync(source, selector) {
    if (typeof selector === "string") {
        return selectAsync_2(source, selector);
    }
    else {
        return selectAsync_1(source, selector);
    }
}
function selectAsync_1(source, selector) {
    async function* iterator() {
        for await (const value of source) {
            yield selector(value);
        }
    }
    return new BasicAsyncEnumerable(iterator);
}
function selectAsync_2(source, key) {
    async function* iterator() {
        for await (const value of source) {
            yield value[key];
        }
    }
    return new BasicAsyncEnumerable(iterator);
}
