import { ErrorString } from "../../shared/ErrorString";
import { InvalidOperationException } from "../../shared/InvalidOperationException";
export function average(source, selector) {
    if (selector) {
        return average_2(source, selector);
    }
    else {
        return average_1(source);
    }
}
async function average_1(source) {
    let value;
    let itemCount;
    for (const item of await source.toArray()) {
        value = (value || 0) + item;
        itemCount = (itemCount || 0) + 1;
    }
    if (value === undefined) {
        throw new InvalidOperationException(ErrorString.NoElements);
    }
    return value / itemCount;
}
async function average_2(source, func) {
    let value;
    // tslint:disable-next-line:no-shadowed-variable
    let count;
    for (const item of await source.toArray()) {
        value = (value || 0) + func(item);
        count = (count || 0) + 1;
    }
    if (value === undefined) {
        throw new InvalidOperationException(ErrorString.NoElements);
    }
    return value / count;
}
