import { ErrorString } from "../../shared/ErrorString";
import { InvalidOperationException } from "../../shared/InvalidOperationException";
export function average(source, selector) {
    if (selector) {
        return average_2(source, selector);
    }
    else {
        return average_1(source);
    }
}
function average_1(source) {
    let value;
    let count;
    for (const item of source) {
        value = (value || 0) + item;
        count = (count || 0) + 1;
    }
    if (value === undefined) {
        throw new InvalidOperationException(ErrorString.NoElements);
    }
    return value / count;
}
function average_2(source, func) {
    let value;
    let count;
    for (const item of source) {
        value = (value || 0) + func(item);
        count = (count || 0) + 1;
    }
    if (value === undefined) {
        throw new InvalidOperationException(ErrorString.NoElements);
    }
    return value / count;
}
