import { ErrorString } from "../../shared/ErrorString";
import { InvalidOperationException } from "../../shared/InvalidOperationException";
export function max(source, selector) {
    if (selector) {
        return max_2(source, selector);
    }
    else {
        return max_1(source);
    }
}
function max_1(source) {
    let maxItem = null;
    for (const item of source) {
        maxItem = Math.max(maxItem || Number.NEGATIVE_INFINITY, item);
    }
    if (maxItem === null) {
        throw new InvalidOperationException(ErrorString.NoElements);
    }
    else {
        return maxItem;
    }
}
function max_2(source, selector) {
    let maxItem = null;
    for (const item of source) {
        maxItem = Math.max(maxItem || Number.NEGATIVE_INFINITY, selector(item));
    }
    if (maxItem === null) {
        throw new InvalidOperationException(ErrorString.NoElements);
    }
    else {
        return maxItem;
    }
}
