import { ErrorString } from "../../shared/ErrorString";
import { InvalidOperationException } from "../../shared/InvalidOperationException";
export function min(source, selector) {
    if (selector) {
        return min_2(source, selector);
    }
    else {
        return min_1(source);
    }
}
function min_1(source) {
    let minItem = null;
    for (const item of source) {
        minItem = Math.min(minItem || Number.POSITIVE_INFINITY, item);
    }
    if (minItem === null) {
        throw new InvalidOperationException(ErrorString.NoElements);
    }
    else {
        return minItem;
    }
}
function min_2(source, selector) {
    let minItem = null;
    for (const item of source) {
        minItem = Math.min(minItem || Number.POSITIVE_INFINITY, selector(item));
    }
    if (minItem === null) {
        throw new InvalidOperationException(ErrorString.NoElements);
    }
    else {
        return minItem;
    }
}
